variables:
  BIN_NAME: prometheus-config
  ARTIFACTS_DIR: artifacts
  GO_PROJECT: gitlab.com/trademarkvision/docker/prometheus-config

stages:
  - build
  - release-tag
  - release-branch

build-prometheus-config:
  stage: build
  image: golang:1.12
  before_script:
    - env GO111MODULE=on
    - mkdir -p ${GOPATH}/src/${GO_PROJECT}
    - mkdir -p ${CI_PROJECT_DIR}/${ARTIFACTS_DIR}
    - go get -u github.com/mitchellh/gox
    - cp -r ${CI_PROJECT_DIR}/* ${GOPATH}/src/${GO_PROJECT}
    - cd ${GOPATH}/src/${GO_PROJECT}
  script:
    - CGO_ENABLED=0 GO111MODULE=on gox -osarch="linux/amd64" -output="${CI_PROJECT_DIR}/${ARTIFACTS_DIR}/${BIN_NAME}" ./cmd/config
  artifacts:
    paths:
      - ${ARTIFACTS_DIR}

release-tag-prometheus-config:
  stage: release-tag
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
    IMAGE_TAG: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
    IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
  services:
    - docker:dind
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker info
  script:
    - docker build -t ${IMAGE_LATEST} -f ./build/package/Dockerfile .
    - docker tag ${IMAGE_LATEST} ${IMAGE_TAG}
    - docker push ${IMAGE_LATEST}
    - docker push ${IMAGE_TAG}
  after_script:
    - docker logout ${CI_REGISTRY}
  when: manual
  only:
    - tags

release-branch-prometheus-config:
  stage: release-branch
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
    IMAGE_TAG: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
  services:
    - docker:dind
  before_script:
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker info
  script:
    - docker build -t ${IMAGE_TAG} -f ./build/package/Dockerfile .
    - docker push ${IMAGE_TAG}
  after_script:
    - docker logout ${CI_REGISTRY}
  except:
    - tags
    - /^master$/